#----------------------------------------
# get the values...

# for each target...
for $t ( 0 .. $#details) {
    
  undef %values_by_time;
  undef %dss_by_time;
  undef $first_timestamp;

  if ( $debug ) { print scalar localtime(time), ": $details[$t][0][0]\n"; }

  # for each variable instance...
  variable_instance:
  for $i ( 0 .. $#{$details[$t]} ) {

    $target = $details[$t][$i][0];
    $system = $details[$t][$i][1];
    $passwd = $details[$t][$i][2];
    $var = $details[$t][$i][3];
    $ds = $details[$t][$i][4];
    $rrd = $details[$t][$i][5];
    $timeout = $details[$t][$i][5];
    $get_has_timed_out = 0;

    if ( $var =~ s/^exec\s+// ) {
      if ( $debug ) { print "$var 2>&1\n"; }
      if ( ! open(IN,"$var 2>&1|") ) {
        print STDERR "$progname: can not execute $var\n";
        next variable_instance;
      }
      alarm $timeout;
      $stamp = <IN>; chop $stamp;
      $value = <IN>; chop $value;
      if ( ! close(IN) ) {
        alarm 0;
        print STDERR "$progname: can not close $var\n";
        next variable_instance;
      }
      alarm 0;
      $stamp =~ s/(\d+).*/$1/;
      $value =~ s/(\d+).*/$1/;
      if ( $debug ) { print "$stamp:$value\n"; }
      if ( ! $stamp || ! $value ) {
        $exec_name = (split(/\s+/,$var))[0];
        if ( $get_has_timed_out ) {
           print "$progname timed out: $var\n";
        } else {
           print "$progname: $exec_name failed: can't parse \"$value\"\n";
        }
        next variable_instance;
      }
    } else {
      switch: { 
        if ( 'cmu-snmp' eq 'cmu-snmp' ) {  # SNMPGET_TYPE cmu-snmp
          if ( $debug ) { print "snmpget $system $passwd $var 2>&1\n"; }
          $snmpget_cmd = "$snmpget $system $passwd $var 2>&1";
	  last switch;
        }
        if ( 'cmu-snmp' eq 'netview' ) {  # SNMPGET_TYPE netview
          if ( $debug ) { print "snmpget -c passwd $system $var 2>&1\n"; }
          $snmpget_cmd = "$snmpget -c $passwd $system $var 2>&1";
	  last switch;
        }
        print STDERR "$progname: error: no such snmpget type:";
        print STDERR " cmu-snmp\n";
        next variable_instance;
      }
      $stamp = time;
      alarm $timeout;
      if ( ! open(IN,"$snmpget_cmd|") ) {
        print STDERR "$progname: can not execute $snmpget_cmd\n";
        next variable_instance;
      }
      $value = <IN>;
      if ( ! close(IN) ) {
        alarm 0;
        print STDERR "$snmpget: can not close $snmpget_cmd\n";
        next variable_instance;
      }
      alarm 0;
      chop $value;
      if ( $value =~ /\s*=\s*(\d+)\s*$/ || $value =~ /\s*:\s*(\d+)\s*$/ ) { 
        $value = $1;
      } else {
        # snmpget failed...
        if ( $get_has_timed_out ) {
           print "$progname timed out: $var\n";
        } else {
          $value =~ s/\n/ /g;
          $value =~ s/  / /g;
          print "$progname: snmpget $system $passwd $var failed...\n";
          print "$progname: $value\n";
        }
        next variable_instance;
      }
    }
    if ( 'yes' eq 'yes' ) {  # FUDGE_RRDTOOL_UPDATE
      # with rrdtool 1.0.7 doing 
      #     rrdtool update some.rrd -t output time_one:val_a
      #     rrdtool update some.rrd -t input time_one+1:val_b
      # causes rrdtool to not graph the later datapoint!
      # so here we fudge the times for each rrd to do
      #     rrdtool update some.rrd time_one:val_a:val_b
      #
      if ( $first_timestamp ) {
        $stamp = $first_timestamp;
      } else {
        $first_timestamp = $stamp
      }
    }
    $values_by_time{$stamp} .= ":$value";
    $dss_by_time{$stamp} .= ":$ds";
  }

  for $stamp (sort (keys %values_by_time)) {
    $values = $values_by_time{$stamp};
    $dss = $dss_by_time{$stamp};
    $dss =~ s/^://;
    if ( $debug ) { print "$rrdtool update $rrd -t $dss ${stamp}$values\n"; }
    alarm $exec_timeout;
    $out = `$rrdtool update $rrd -t $dss ${stamp}$values 2>&1`;
    alarm 0;

    if ( $debug ) { 
      if ( 'no' eq 'yes' ) {  # VERBOSE_RRDTOOL_LAST
        print `$rrdtool last -c $rrd`;
        print `$rrdtool last -v $rrd`, "\n";
      } else {
        print `$rrdtool last $rrd`, "\n";
      }
    }
    if ( $get_has_timed_out ) {
      print "$progname timed out: $rrdtool update $rrd -t $dss ${stamp}$values\n";
    } else {
      if ( $out !~ /^\s*$/ ) {
        print "$progname: \"$rrdtool update $rrd -t $dss ${stamp}$values\" failed\n";
        print "$progname: rrdtool said: \"$out\"\n";
      }
    }
  }

}

#----------------------------------------
# unlock and exit...

unlink $lock;

exit 0;

#==============================================================================

sub abend {
  $date = scalar localtime(time);
  print STDERR "$progname: killed (timed out) on $date\n";
  unlink $lock;
  exit 1;
}

#------------------------------------------------------------------
sub timed_out {
  local $SIG{HUP} = 'IGNORE';
  # kill my children...
  kill('HUP', -$$);
  $get_has_timed_out = 1;
}

